﻿Type=Activity
Version=1.77
FullScreen=True
IncludeTitle=False
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim Transpose As Int

	Dim Song, SongTitle ,Composer,Style ,Key ,ImportFlag, SongNotes, Media As String
	Dim SetListNotes As String
	
	Dim KeyType ,TransKey As String
	Dim TimeSig As String
	Dim MaxDispWidth As Int				'Use to restrict display width to acheive see through activity

	Dim Minor As String
	Dim CTMFLag As Boolean
	
	Dim Viewheight As Int
	
	Dim MP As MediaPlayer
	Dim MPFileLoaded As Boolean
	Dim LastFilePath As String
	
	Dim MediaPnlTop, MediaPlayBtnTop,MediaPlayBtnLeft,CurrMPY As Int
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Dim ChordDisplay ,Piano , NotesWindow, Piano As Panel 
	Dim ScrollView1,NotesScroll As ScrollView
	Dim NotesText As EditText
	Dim Canvas1 As Canvas
	
	Type DispOpts(TI As Int,SM As Int,CT As Int,ST As Int,BT As Int,TT As Int,TS As Int,TE As Int,CY As Int,TY As Int,SX As Int,SXS As Int,SXA As Int,SXAS As Int,SY As Int,MX As Int,MXS As Int,MXA As Int,MXAS As Int,MY2 As Int,MXL As Int,MXLS As Int,MY3 As Int)

	Dim CurrOpts,CurrOptsBak As DispOpts
	
	'Dim LabSongTitle As Label
	
	Dim OnF As Reflector
	
	'Used to determine swip on chord display
	Dim CDTouchX As Int
	
	Dim NDLabCompTxt As Label
	Dim NDLabStyTxt As Label
	Dim NOBtnTrans As Button
	Dim NOLblCuKey As Label
	Dim NOLblSTKey As Label
	Dim NoBtnEdClose As Button
	Dim NDTitle As Label
	Dim NDBtnFS As Button
	
	Dim MsgIcon As Bitmap
	Dim NOPnlKeyInfo As Panel
	Dim FFwd As Button
	Dim MediaLbl As Label
	Dim MediaPlayBtn As Button
	Dim MediaPnl As Panel
	Dim Pause As Button
	Dim Rew As Button
	Dim Timer1,MediaPlayTimer,TimeDispTimer As Timer
	Dim TimeCount As Int
	Dim MediaCountDown,MediaPnlCount As Int
	
	Dim MediaCDLbl As Label
	Dim KarFile As Boolean
	Dim KarFileName As String
	Dim MPYOffSet, MPYStart, MPYComp As Int

	Dim NextSongLbl As Label
	Dim NoTimeLbl As Label
	Dim TimePnl As Panel
	Dim TimePULbl As Label
	
	Dim NextSongTitle As String
	
	Dim NOTabPnl As Panel
	
	Dim SetListNotesFlag As Boolean
	
	Dim SLNoOlay As Label
	Dim SLNotesHighlight As Label
	Dim SLOLTitle As Label
	
	Dim SLNotesOverlayPnl As Panel
	
	Dim CLDevIDLbl As Label
	Dim CLFontSizes As Spinner
	Dim CLFontSizesET As EditText
	Dim CLPnlBG As Panel
	Dim CLTypeDisp As Spinner
	Dim CLTypeDispET As EditText
	Dim CLFontSizeLbl As Label
	Dim CLFontSizesLblBG As Label
	Dim CLTypeDispLbl As Label
	Dim CLTypeDispLblBG As Label
	Dim CLSeekBar As SeekBar
	Dim CLPnl As Panel
	Dim ClPnlMove As Panel


	Dim CLPnlBGColour As Int
	Dim ETXOffSet,ETYOffSet,ETXStart,ETYStart,ETXComp,ETYComp,ETXOrig,ETYOrig As Int
	
	Dim SBFontMin,SBTypeMin,SBFontMax,SBTypeMax As Int
	
	Dim NotesOptPnl As Panel
	Dim NotesOptPnlBG As Panel
	Dim NPFontSize As Label
	Dim NPSBFontSize As SeekBar
	Dim NPNotesColors As CheckBox
	Dim NOEText As EditText
	Dim PianoKeysPnl As Panel
	
	Dim NotesOptColorSp As Spinner
	Dim NotesOptCurrLbl As Label
	Dim OrientationLock As Button
	
	Dim ScreenHeight,ScreenWidth As Int
	
	Dim ActivityPanel As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Shared.Process = "Display"

	If Shared.ScreenWidth <=0 Then
		Msgbox("A problem has occurred probably low memory, chordpad needs to restart","Memory Low!")
		Activity.Finish
	End If
	
	ScreenHeight= Activity.Height
	ScreenWidth = Activity.Width
	
	Activity.LoadLayout("chordlayout.bal")

	
		'Tablet Specific
	If Main.DeviceType = "T" Then
	
		Utils.CheckOrientLock(OrientationLock)

		
		If ReflOrient.GetScreenRotation=1 Then
		'Portrait
			Utils.ScalePanel(ScreenWidth,ScreenHeight,CLPnlBG,True,Array As Object(CLPnl))
		Else
		'Landscape			
			'ScreenWidth=Utils.GetWidth(MainScreenHeight,SongListPnl)
			If ReflOrient.OrientLock.MaintainAspect Then
				ScreenWidth=Utils.GetWidth(ScreenHeight,CLPnlBG)
			Else
				ScreenWidth=Utils.SetScreenWidth(ScreenWidth)
			End If
			Utils.ScalePanel(ScreenWidth,ScreenHeight,CLPnlBG,True,Array As Object(CLPnl))
			
			'Generate a background
			ActivityPanel=Utils.GenerateBG(100%x,100%y )
			Activity.AddView(ActivityPanel,0,0,100%x,100%y)
			ActivityPanel.Visible=True
			ActivityPanel.SendToBack

			'Need to size orientation lock as it is on activity for ShowSong
			Utils.ScaleView(OrientationLock,"N")
		End If
	Else
		ScreenWidth = Activity.Width
		'Force orientation lock to portrait
		Dim p As Phone
		p.SetScreenOrientation(1)
		Utils.ScalePanel(ScreenWidth,ScreenHeight,CLPnlBG,True,Array As Object(CLPnl))
		ReflOrient.OrientLock.Enabled=False
		OrientationLock.Visible=False
	End If
	
	'Update Shared Screen variables so it's available to Modules
	Shared.ScreenHeight=ScreenHeight
	Shared.ScreenWidth=ScreenWidth
	
	CLPnlBG.SetLayout(0,0,ScreenWidth,ScreenHeight)
	CLPnl.Top=(CLPnlBG.Height-CLPnl.Height)/2
	CLPnl.Left=(CLPnlBG.Width-CLPnl.Width)/2

	ScrollView1.Initialize(ScreenHeight)
	Activity.AddView(ScrollView1,0,0,ScreenWidth,ScreenHeight)
	ScrollView1.Color= Colors.Black
	ScrollView1.Visible=False

	ChordDisplay.Initialize("ChordDisplay")

	ScrollView1.Panel.AddView(ChordDisplay, 0, 0, ScreenWidth, ScreenHeight)
	Canvas1.Initialize(ChordDisplay)
	

	If Main.ReturnTo.get(Main.ReturnTo.Size-1) = "Set" Then				'Only if called from setlists
		
		NextSongLbl.Initialize("NextSongLbl")
		NextSongTitleWidth = ScreenWidth
		NextSongTitleHeight = 20
		NextSongTitleX=(ScreenWidth-NextSongTitleWidth)/2
		NextSongTitleY=ScreenHeight-NextSongTitleHeight
		ChordDisplay.AddView(NextSongLbl,NextSongTitleX,NextSongTitleY,NextSongTitleWidth,NextSongTitleHeight)
		NextSongLbl.TextSize=14
		NextSongLbl.Gravity=Gravity.CENTER
		NextSongLbl.Visible=False
		
		Activity.LoadLayout("SLNotesOverlay.bal")
		SLNotesOverlayPnl.Top=NextSongLbl.Top-SLNoOlay.Height-20
		SLNotesOverlayPnl.Width=ScreenWidth
		SLNotesOverlayPnl.Height=SLNotesOverlayPnl.Height+20
		SLNotesOverlayPnl.Left=0
		SLNoOlay.Width=ScreenWidth
		
		SLNotesHighlight.Initialize("SLNotesHighlight")
		
		SLNotesOverlayPnl.AddView(SLNotesHighlight,SLNoOlay.Left,SLNoOlay.Top,SLNoOlay.Width,SLNoOlay.Height+20)
		SLNoOlay.Height=SLNoOlay.Height-4
		SLNoOlay.Width=SLNoOlay.Width-4
		SLNoOlay.Top=SLNoOlay.Top+22
		SLNoOlay.Left=SLNoOlay.Left+2
		SLNotesHighlight.Color=Colors.Gray
		SLOLTitle.Initialize("SLOLTitle")
		SLNotesOverlayPnl.AddView(SLOLTitle,0,0,ScreenWidth,20)
		SLOLTitle.Text="Setlist notes - touch to dismiss"
		SLOLTitle.TextColor=Colors.Black
		
		SLNoOlay.BringToFront
		SLNoOlay.TextSize=UserOptions.NotesFontSize
	
		'Set Colours
		If UserOptions.NotesColors="W" OR (UserOptions.NotesColors="A" AND UserOptions.ScreenColors = "W") Then
			SLNoOlay.Color=Colors.Black
			SLNoOlay.TextColor=Colors.White
		End If
	End If

	
	LoadCLSpinners
	
	CreateMenus
	
	If FirstTime Then
		MP.Initialize
		KarFile=False
	End If
		
	'Initialize timers and related counters
	Timer1.Initialize("Timer1",1000)
	TimeDispTimer.Initialize("TimeDispTimer",1000)
	MediaPlayTimer.Initialize("MediaPlayTimer",1000)
	MediaPnlCount=0
	
	BuildSong.GetDisplayColours
	BuildSong.GetDisplaySizes
	
	DisplaySong.MeasureStrings(Canvas1)
	BuildSong.CreateLayout
	
	MsgIcon=Shared.LoadImages
	
	DateTime.TimeFormat="HH:mm"
	
	'Store the original position of ChordLayout panel
	ETXOrig=CLPnl.Left
	ETYOrig=CLPnl.Top
	
	'Min-Max values for Fonts and Type values
	SBFontMin=8
	SBFontMax = 50
	SBTypeMin=-30
	SBTypeMax = 30

	If ReflOrient.OrientLock.Enabled Then
		OrientationLock.Visible=True
		OrientationLock.BringToFront
	End If
	


End Sub
Sub LoadNotesLayout
	SetListNotesFlag=False
	If Main.ReturnTo.get(Main.ReturnTo.Size-1) = "Set" Then
		Activity.LoadLayout("setlistnotesdisp.Bal")
		NotesText.Height=ScreenHeight-NDTitle.Height-NOPnlKeyInfo.Height-NOTabPnl.Height
		NotesText.Width=ScreenWidth
		If UserOptions.SetListNotes Then SetListNotesFlag=True
	Else
		Activity.LoadLayout("notesdisp.Bal")
		NotesText.Height=ScreenHeight-NDTitle.Height-NOPnlKeyInfo.Height
		NotesText.Width=ScreenWidth
	End If
	If UserOptions.NotesColors="W" OR(UserOptions.NotesColors="A" AND UserOptions.ScreenColors = "W") Then
		NotesText.Color=Colors.Black
		NotesText.TextColor=Colors.White
	End If
	NotesText.TextSize=UserOptions.NotesFontSize
	
End Sub

Sub Activity_Resume

	Shared.CheckPhoneWakeState

	If Main.NewSong OR EditSong.NewRowID <> -1 Then Activity.Finish
	LoadSong(Main.CurrSongRowPos)
End Sub

Sub Activity_Pause (UserClosed As Boolean)

	'Allow the Phone to turn off the screen
	
	Shared.Awake.ReleaseKeepAlive
	If MP.IsPlaying Then MP.Pause
    Timer1.Enabled = False
	MediaPlayTimer.Enabled=False
	If TimePnl.IsInitialized Then TimePnl.Visible = False
	TimeDispTimer.Enabled=False
	
	Shared.SaveUserOptions
	BuildSong.SaveDispOpts
	
	If KarFile Then DeleteKarFile

End Sub
Sub Activity_Keypress(KeyCode As Int) As Boolean

	If KeyCode = KeyCodes.KEYCODE_BACK Then
	
		'Check for and Manage Popups And Menus
		Found=CloseOpenPopups
		If Found Then Return True
		ToastMessageShow("Closing Song...",False)
		If Main.ReturnTo.get(Main.ReturnTo.Size-1) = "Set" Then SetLists.AddThis=0

		Main.ReturnTo.RemoveAt(Main.ReturnTo.Size-1)
		Activity.Finish
	End If

End Sub
Sub CloseOpenPopups
	'Manage Popups and Menus
	
	
	If Piano.IsInitialized AND Piano.Visible Then
		Piano.Visible=False
		'Turn This Off first, Press again if others are still open
		Return True
	End If
	
	If NotesOptPnlBG.IsInitialized Then
		If NotesOptPnlBG.Visible Then
			NotesOptPnlBG.Visible = False
			Return True
		End If
	End If
	
	If NotesWindow.IsInitialized AND NotesWindow.Visible Then
		' Ensure that data entered is saved
		NotesToggle
		'Turn This Off first, Press again if others are still open
		Return True
	End If
	
	
	
	If CLPnlBG.Visible Then
		CLPnlBG.Visible=False
		Return True
	End If
	
	Return False
End Sub
Sub CreateMenus

Activity.AddMenuItem("Song List","Menu_Handler")
Activity.AddMenuItem("Add To Set List","Menu_Handler")
Activity.AddMenuItem("Edit Song","Menu_Handler")
Activity.AddMenuItem("Link To Sound File","Menu_Handler")
Activity.AddMenuItem("Email As Jpeg","Menu_Handler")
Activity.AddMenuItem("Save Song Locally (.db file)","Menu_Handler")
Activity.AddMenuItem("Send Song - Email (.db file)","Menu_Handler")
Activity.AddMenuItem("Edit Chord Layout","Menu_Handler")
Activity.AddMenuItem("Notes Screen Options","Menu_Handler")

End Sub
Sub Menu_Handler_Click

	If MP.IsPlaying Then
		MP.Stop
		MediaPnl.Visible=False
		If KarFile Then DeleteKarFile
	End If
	
	Dim Send As String
		
	Text = Sender
	
	If Text.StartsWith("Song") Then
		Activity.Finish
	End If
	
	If Text.StartsWith("Notes") Then
		NotesOptions
	End If

	If Text.StartsWith("Add") Then
		SetLists.AddThis = Main.CurrSongRowID
		SetLists.SetListMode="Set"
		StartActivity(SetLists)
	End If
	
	If Text.EndsWith("Layout") Then
		SetupChordLayoutPnl
		Return
	End If
	
	If Text.StartsWith("Edit") Then
		ToastMessageShow("Loading Editor ...",False)
		StartActivity(EditSong)
	End If
	If Text.StartsWith("Email") Then
		Shared.CreateImgEmail(Canvas1,"email.jpg",SongTitle,ScreenWidth,ScreenHeight)
		Return
	End If
	If Text.StartsWith("Send") Then
		Shared.SendSong(False)
		'Make sure the song is transposed correctly after sending in stored key
		If TransKey <> "" Then
			Transpose = 1
			BuildSong.BuildOutput
			DisplaySong.DisplaySong(Canvas1,ScreenWidth,ScreenHeight)
		End If
		Return
	End If
	If Text.StartsWith("Save") Then
		Shared.SendSong(True)
		'Make sure the song is transposed correctly after sending in stored key
		If TransKey <> "" Then
			Transpose = 1
			BuildSong.BuildOutput
			DisplaySong.DisplaySong(Canvas1,ScreenWidth,ScreenHeight)
		End If
		Return
	End If
	If Text.StartsWith("Link")Then
		LinkAudio
	End If

End Sub

Sub ChordDisplay_Touch(Action As Int, tx As Float, ty As Float)
	
	
	' Capture Gestures
	'Difference to determing a move over a touch
	Moved = 20
	TurnPagePerc = 20
	XTapPerc=10
	
	If Action = 0 Then					'Touch Down
		CDTouchX = tx
		
		Return True
	End If
	
	If Action = 1 Then   'Touch Up
		If CDTouchX - tx >  Moved Then
			'Swipe Left
			If MP.IsPlaying AND UserOptions.AllowSwipe=False Then Return
			If NotesWindow.IsInitialized Then NotesWindow.Visible = False
			If Main.CurrSongRowPos = Main.SongListRowID.Size -1 Then Return True
			If MP.IsPlaying Then
				MP.Stop
				If KarFile Then DeleteKarFile
			End If
			
			If MediaPlayBtn.IsInitialized Then MediaPlayBtn.Visible=False
			If MediaPnl.IsInitialized Then MediaPnl.Visible=False
			
			LoadSong(Main.CurrSongRowPos+1)
			Return
		Else If tx - CDTouchX > Moved Then
			'Swipe Right
			If MP.IsPlaying AND UserOptions.AllowSwipe=False Then Return True
			If NotesWindow.IsInitialized Then NotesWindow.Visible = False
			If Main.CurrSongRowPos = 0 Then Return
			If MP.IsPlaying Then
				MP.Stop
				If KarFile Then DeleteKarFile
			End If
			If MediaPlayBtn.IsInitialized Then MediaPlayBtn.Visible=False
			If MediaPnl.IsInitialized Then MediaPnl.Visible=False
			LoadSong(Main.CurrSongRowPos-1)
			Return
		End If
	
		' Just Touched - No move
		If UserOptions.TopTap AND ty/ScreenHeight*100 <= XTapPerc Then
			'TopTap Go back
			Activity_Keypress(KeyCodes.KEYCODE_BACK)
			Return True
		Else If UserOptions.BotTap AND 100-(ty/ScreenHeight*100) <= XTapPerc Then
			
			If TimePnl.IsInitialized = False Then
				Activity.LoadLayout("TimePopUp.Bal")
				'Position Pop Up
				TimePnl.Left=(ScreenWidth-TimePnl.Width)/2
				TimePnl.Top=(ScreenHeight-TimePnl.Height)/3
			End If
			
			' Display time pop up & Start counter
			TimeCount=0
			TimeDispTimer.Enabled=True
			TimePULbl.Text=DateTime.Time(DateTime.Now)
			TimePnl.Visible=True
		Else If 100-(tx/ScreenWidth*100) <= TurnPagePerc Then
			'Tap Left
			If MP.IsPlaying AND UserOptions.AllowSwipe=False Then Return
			If NotesWindow.IsInitialized Then NotesWindow.Visible = False
			If Main.CurrSongRowPos = Main.SongListRowID.Size -1 Then Return True
			If MP.IsPlaying Then
				MP.Stop
				If KarFile Then DeleteKarFile
			End If
			If MediaPlayBtn.IsInitialized Then MediaPlayBtn.Visible=False
			If MediaPnl.IsInitialized Then MediaPnl.Visible=False
			LoadSong(Main.CurrSongRowPos+1)
			Return
		Else If tx/ScreenWidth*100 <= TurnPagePerc Then
			'Tap Right
			If MP.IsPlaying AND UserOptions.AllowSwipe=False Then Return True
			If NotesWindow.IsInitialized Then NotesWindow.Visible = False
			If Main.CurrSongRowPos = 0 Then Return
			If MP.IsPlaying Then
				MP.Stop
				If KarFile Then DeleteKarFile
			End If
			If MediaPlayBtn.IsInitialized Then MediaPlayBtn.Visible=False
			If MediaPnl.IsInitialized Then MediaPnl.Visible=False
			LoadSong(Main.CurrSongRowPos-1)
			Return
		Else
			'Toggle Notes Panel
			NotesToggle
		End If
	End If
End Sub
Sub NotesToggle
	
	If NotesWindow.IsInitialized=False Then LoadNotesLayout
	
	If NotesWindow.Visible = True Then
	'Turn Off
		NotesWindow.Visible = False
		NotesWindow.Enabled=False
		
		If SetListNotesFlag Then
			'Update SetList Notes
			If SetListNotes<>NotesText.Text Then
				SetListNotes=NotesText.Text
				Main.SongsDB.Initialize(File.DirDefaultExternal, "Songs.db", False)
				Main.SongsDB.ExecNonQuery2("UPDATE PlayListDat SET PLNotes = ? WHERE SongRowID = ? AND PLNAME = ?",Array As String(SetListNotes,Main.CurrSongRowID,SetLists.CurrentPlayList))
				Main.SongsDB.Close
			End If		
		Else
			'Update notes
			If SongNotes<>NotesText.Text Then
				SongNotes=NotesText.Text
				Main.SongsDB.Initialize(File.DirDefaultExternal, "Songs.db", False)
				Main.SongsDB.ExecNonQuery2("UPDATE Songs SET Notes = ? WHERE ROWID = ?",Array As String(SongNotes,Main.CurrSongRowID))
				Main.SongsDB.Close
			End If
		End If
		
		If UserOptions.DisplayTransport AND Media <> "" Then
				If MediaPnl.IsInitialized= False Then
					'Load Media Panel
					Activity.LoadLayout("Media.bal")
					MediaPnlTop=MediaPnl.Top
					MediaPlayBtnTop=MediaPlayBtn.Top
					MediaPlayBtnLeft = MediaPlayBtn.Left
				End If
				MediaPnl.Top=CurrMPY
				MediaPlayBtn.Top=MediaPnl.Top
				If MP.IsPlaying Then
					MediaPlayBtn.Left=MediaPlayBtnLeft
					MediaPnl.Visible=True
				Else
					MediaPnl.Visible=False
					MediaPlayBtn.Left=0
					MediaPlayBtn.Top=0

				End If
				MediaPlayBtn.Visible=True
		Else
			If MediaPnl.IsInitialized Then
				'Don't Display MediaPnl
				MediaPnl.Visible=False
				MediaPlayBtn.Visible=False
			End If
		End If
		
	Else
		NotesText.Text=""

		If SetListNotesFlag Then
			If SetListNotes = "" Then
				If SongNotes <> "" Then
					SetListNotesFlag=False
					'Load Title
					NDTitle.Text="Song Notes For "&SongTitle
					'Load Notes
					NotesText.Text=SongNotes
				Else
					'Load Title
					NDTitle.Text="Set List Notes For "&SongTitle
					NotesText.Text = SetListNotes
				End If
			Else
				'Load Title
				NDTitle.Text="Set List Notes For "&SongTitle
				NotesText.Text = SetListNotes
			End If
		Else
			'Load Title
			NDTitle.Text="Song Notes For "&SongTitle
			'Load Notes
			NotesText.Text=SongNotes
		End If
		
		'Turn off overlay panel
		If SLNotesOverlayPnl.IsInitialized AND SLNotesOverlayPnl.Visible=True Then SLNotesOverlayPnl.Visible=False
		
		'Load orig key and transposed key
		NOLblSTKey.Text="Stored Key "&Key.Replace("-",Minor)
		If TransKey <> "" Then
			NOBtnTrans.Text=TransKey.Replace("-",Minor)
		Else
			NOBtnTrans.Text=Key.Replace("-",Minor)
		End If
		
		'Display Time
		NoTimeLbl.Text=DateTime.Time(DateTime.Now)
		
		'Turn on window
		NotesWindow.Enabled=True
		NotesWindow.Visible = True
		NotesWindow.BringToFront
		
		'Display media panel if needed
		If Media <> "" Then
			If MediaPnl.IsInitialized=False Then
				'Load Media Panel
				Activity.LoadLayout("Media.bal")
				MediaPnlTop=MediaPnl.Top
				MediaPlayBtnTop=MediaPlayBtn.Top
				MediaPlayBtnLeft = MediaPlayBtn.Left
			End If
			'Set Position
			CurrMPY=MediaPnl.Top
			MediaPnl.Top=MediaPnlTop
			MediaPlayBtn.Top=MediaPlayBtnTop
			MediaPlayBtn.Left=MediaPlayBtnLeft
			'Display Panel
			If MP.IsPlaying OR MediaPlayTimer.Enabled Then
				MediaPnl.Visible=True
				MediaPnl.BringToFront
			End If
			'Display Play btn
			MediaPlayBtn.Visible=True
			MediaPlayBtn.BringToFront
		End If
	End If
End Sub
Sub LoadSong(Position As Int)

	'Remove Temp Midi used to allow Kar File to play
	If KarFile Then DeleteKarFile

	'LabSongTitle.Visible=True
	ScrollView1.Visible=True
	ChordDisplay.Visible=True
	'For moving items in playlist	
	
	
	Main.SongsDB.Initialize(File.DirDefaultExternal, "Songs.db", False)
	
	Dim Cursor1 As Cursor
	Dim Cursor2 As Cursor
	Dim Cursor3 As Cursor
	
	
	Main.CurrSongRowId=Main.SongListRowID.Get(Position)	'Store ID from DB
	Main.CurrSongRowPos=Position
	
	Transpose=0
	Media=""
	SetListNotesFlag=False
	If SLNotesOverlayPnl.IsInitialized Then SLNotesOverlayPnl.Visible=False

	Cursor1=Main.SongsDB.ExecQuery2("SELECT * FROM Songs WHERE rowid = ?", Array As String(Main.CurrSongRowId))
		
	Select Main.ReturnTo.get(Main.ReturnTo.Size-1)
	
		Case "Main","Comp","Styl"
	
			Cursor2=Main.SongsDB.ExecQuery2("SELECT Key From Transpose Where SongRowID = ?", Array As String(Main.CurrSongRowId))
	
		Case "Set"
		
			Cursor2=Main.SongsDB.ExecQuery2("SELECT * From PlayListDat Where SongRowID = ? AND PLName = ?", Array As String(Main.CurrSongRowId,SetLists.CurrentPlayList))
			If Main.CurrSongRowPos+1 >= Main.SongListRowID.Size Then
				NextSongLbl.TextColor=Colors.Cyan
				NextSongTitle="End Of Set List"
			Else
				ThisRowID=Main.SongListRowID.Get(Main.CurrSongRowPos+1)
				Cursor3=Main.SongsDB.ExecQuery2("SELECT Song_Title FROM Songs WHERE rowid = ?", Array As String(ThisRowID))
				Cursor3.Position=0
				NextSongTitle=Cursor3.GetString("Song_Title")
				NextSongLbl.TextColor=Colors.White
			End If
	End Select
	
	Cursor1.Position=0
	Cursor2.Position=0

	SongTitle=Cursor1.GetString("Song_Title")
	Composer=Cursor1.GetString("Composer")
	Style=Cursor1.GetString("Style")
	Key=Cursor1.GetString("Key")
	ImportFlag=Cursor1.GetString("ImportFlag")
	Song=Cursor1.GetString("Song")
	SongNotes=Cursor1.GetString("Notes")
	If SongNotes = Null OR SongNotes = "null" Then SongNotes=""
	'Set default incase none in the song
	'Needs spaces to avoid subscript out of range in displaysong
	
	TimeSig=" , "
	

	
	
	If Key.IndexOf("-") = -1 AND Key.IndexOf("m") = -1 Then
		KeyType = "Major"
	Else
		KeyType = "Minor"
	End If
	
	TransKey=""

	Select Main.ReturnTo.get(Main.ReturnTo.Size-1)
	
		Case "Main","Comp","Styl"
			Media=Cursor1.GetString("MediaLink")
			If Media = Null OR Media = "null" Then Media = ""
			If Cursor2.RowCount <> 0 Then	
				TransKey=Cursor2.GetString("Key")
				If TransKey = Null OR TransKey = "null" Then TransKey = ""
			End If
	
		Case "Set"
			If Cursor2.RowCount <> 0 Then
				Media=Cursor2.GetString("MediaLink")
				If Media = Null OR Media = "null" Then Media = ""
				
				TransKey=Cursor2.GetString("Transpose")
				If TransKey = Null OR TransKey = "null" Then TransKey = ""
				
				SetListNotes=Cursor2.GetString("PLNotes")
				If SetListNotes = Null OR SetListNotes = "null" Then SetListNotes = ""
			Else
				Media=""
				TransKey=""
			End If
			
			'Reset SetListNotesFlag in line with user options
			If UserOptions.SetListNotes Then
				SetListNotesFlag=True
			End If
			
			If SLNotesOverlayPnl.IsInitialized AND UserOptions.OverlaySLNotes AND SetListNotes <> "" Then
				SLNoOlay.Text=SetListNotes
				SLNotesOverlayPnl.Visible=True
			End If
	
	End Select
	
	If TransKey <> "" Then
		Transpose = 1
	Else
		Transpose=0
	End If
	'Set MP File Loaded Flag
	MPFileLoaded=False
	
	BuildSong.buildoutput
	DisplaySong.DisplaySong(Canvas1,ScreenWidth,ScreenHeight)
	
	If UserOptions.ShowNext AND Main.ReturnTo.get(Main.ReturnTo.Size-1) = "Set" Then
		NextSongLbl.Text="Next: "&NextSongTitle
		NextSongLbl.Visible=True
	Else
		If NextSongLbl.IsInitialized Then NextSongLbl.Visible=False
	End If
	'Turn on ChordDisplay
	ChordDisplay.Visible=True
	'Display Media Play Button if needed
	
	If UserOptions.DisplayTransport AND Media <> "" Then
		If MediaPnl.IsInitialized=False Then
			'Load Media Panel
			Activity.LoadLayout("Media.bal")
			MediaPnlTop=MediaPnl.Top
			MediaPlayBtnTop=MediaPlayBtn.Top
			MediaPlayBtnLeft = MediaPlayBtn.Left
		End If
		MediaPlayBtn.Top=0
		MediaPlayBtn.Left=0
		MediaPlayBtn.Visible=True
	Else
		If MediaPnl.IsInitialized Then MediaPlayBtn.Visible=False
	End If
	
	If MediaPnl.IsInitialized Then MediaPnl.Visible=False
	
	Main.SongsDB.Close
		
	Activity.Invalidate
	
End Sub
Sub BtnTrans_Click
	If Piano.IsInitialized = False Then
		'Transpose window
		Activity.LoadLayout("Piano.bal")
		Piano.SetLayout(0,0,ScreenWidth,ScreenHeight)
		PianoKeysPnl.Left = (Piano.Width-PianoKeysPnl.Width)/2
	End If
	
	NotesToggle
	Piano.Visible=True
	Piano.BringToFront
End Sub
Sub Tkey_Click
	'Piano Window Choice Made
	Dim Send As View
	Send=Sender
	Piano.Visible = False
	'Just for display of keys in edit window Not for transposing song
	

			
	TransKey=Send.Tag
	TransKey=TransKey.Replace("sh","#")
	If KeyType="Minor" Then KT="-" Else KT=""
	
	If TransKey&KT = Key Then TransKey = "" Else TransKey=TransKey&KT
	
	Main.SongsDB.Initialize(File.DirDefaultExternal, "Songs.db", False)
	
	Dim Cursor1 As Cursor
	
	
	Select Main.ReturnTo.get(Main.ReturnTo.Size-1)
	
	Case "Main","Comp","Styl"
		Cursor1=Main.SongsDB.ExecQuery2("Select Key From Transpose WHERE SongRowID = ?",Array As String(Main.CurrSongRowId))
		If Cursor1.RowCount = 0 Then
			Main.SongsDB.ExecNonQuery2("INSERT INTO Transpose VALUES(?,?)",Array As String(Main.CurrSongRowId,TransKey))
		Else
			Main.SongsDB.ExecNonQuery2("UPDATE Transpose SET Key = ? WHERE SongRowID = ?",Array As String(TransKey,Main.CurrSongRowId))
		End If
	
	Case "Set"

		Main.SongsDB.ExecNonQuery2("UPDATE PlaylistDat SET Transpose = ? WHERE SongRowID = ? AND PLName = ?",Array As String(TransKey,Main.CurrSongRowId,SetLists.CurrentPlayList))
	
	End Select
	Main.SongsDB.Close
	
	' Update Display display mode
	
	'Set transpose as required
	If TransKey = "" Then
		Transpose=0
	Else
		Transpose=1
	End If
	
	NotesWindow.Visible=False
	BuildSong.buildoutput
	DisplaySong.DisplaySong(Canvas1,ScreenWidth,ScreenHeight)
	Transpose=0
	Activity.Invalidate
	
End Sub
Sub NDBtnFS_Click
	If ScreenHeight < 800 Then
		If NotesScroll.Height=200 Then 
				NotesScroll.Height=ScreenHeight-NDTitle.Height
		Else
			NotesScroll.Height=200
		End If
	Else
		If NotesScroll.Height=370 Then
			Log("NSH "&NotesScroll.Height&" SH "&ScreenHeight&" NDT "&NDTitle.Height)
				NotesScroll.Height=ScreenHeight-NDTitle.Height
		Else
			NotesScroll.Height=370
		End If
	End If

End Sub
Sub NotesText_click

End Sub

Sub NotesText_LongClick
	NotesOptions
End Sub
Sub NoBtnEdClose_Click
	NotesToggle
End Sub
Sub LinkAudio

	SelectAudio
	
End Sub
Sub SelectAudio

	If Not(File.IsDirectory(LastFilePath,"")) Then
		LastFilePath = File.DirRootExternal
	End If
	
	Dim FD As FileDialog
	FD.FastScroll=True
	FD.FilePath=LastFilePath
	

	
	FD.Show("Select Media File","Select","Cancel","Remove",Null)
	
	If FD.Response = DialogResponse.CANCEL Then Return
	
	'Remove link
	If FD.Response <> DialogResponse.NEGATIVE Then
		
		Dir=FD.FilePath
		FileName=FD.ChosenName
		
		TestName=FileName.Substring(FileName.Length-3).ToLowerCase
		
		Select TestName
		
			Case "mid","wav","ogg","mp3","3gp","mp4","m4a","xmf","ttl","rtx","ota","imy","kar"
			'Carry on
			
			Case Else
				'Catch everything else
				Return
				
		End Select
		
		LastFilePath=Dir
		
		'Update Global Variable
		Media = File.Combine(Dir,FileName)
		MPFileLoaded = False
	Else
		'Remove the media
		Media = ""
	End If
	
	'Update DB
	Select SetLists.SetListMode
	
		Case "Set"
			Main.SongsDB.Initialize(File.DirDefaultExternal, "Songs.db", False)
			Main.SongsDB.ExecNonQuery2("UPDATE PlayListDat SET MediaLink = ? WHERE SongRowID = ? AND PLNAME = ?",Array As String(Media,Main.CurrSongRowID,SetLists.CurrentPlayList))
			Main.SongsDB.Close
		
		Case "Comp","Styl",""
		
			Main.SongsDB.Initialize(File.DirDefaultExternal, "Songs.db", False)
			Main.SongsDB.ExecNonQuery2("UPDATE Songs SET MediaLink = ? WHERE ROWID = ?",Array As String(Media,Main.CurrSongRowID))
			Main.SongsDB.Close
			
	End Select	
	'Reload Song to display link
	LoadSong(Main.CurrSongRowPos)
End Sub
Sub LoadMedia(Dir As String,FileName As String)
	If Dir&FileName = "" Then Return
	If File.Exists(Dir,FileName)=False Then
		Msgbox("File no longer exists on the SD card "&File.Combine(Dir,FileName),"Can't Find File")
		Return
	End If
	If FileName.EndsWith(".kar") Then
		KarFile=True
		KarFileName=FileName.SubString2(0,FileName.Length-3)&"mid"
		File.Copy(Dir,FileName,Dir,KarFileName)
		FileName=KarFileName
	End If
	MP.Initialize
	MP.Load(Dir,FileName)
	
End Sub
Sub PlayMedia
	MP.Play
	Timer1.Enabled=True
	Timer1_Tick
End Sub
Sub MediaPlayTimer_Tick
	If MediaCDLbl.Visible=False AND MediaCountDown>0 Then
		MediaCDLbl.Visible=True
		MediaCDLbl.BringToFront
	End If

	MediaCDLbl.Text=MediaCountDown
	MediaCountDown=MediaCountDown-1
	If MediaCountDown=-1 Then
		MediaCDLbl.Visible=False
		MediaPlayTimer.Enabled=False
		PlayMedia
	End If

End Sub
Sub Media_Click
	Dim Send As Button
	Send = Sender
	Select Send.Tag
		Case "Play"
			If NotesWindow.Visible = False Then
				MediaPnl.Top=CurrMPY
				MediaPlayBtn.Top=CurrMPY
				MediaPlayBtn.Left = MediaPlayBtnLeft
			Else
				MediaPnl.Top=MediaPnlTop
				MediaPlayBtn.Top=MediaPlayBtnTop
				MediaPlayBtn.Left = MediaPlayBtnLeft
			End If
			
			MediaPnl.Visible=True
			MediaPnl.BringToFront
			MediaPlayBtn.BringToFront
			If MPFileLoaded Then
				If MP.Duration-MP.Position < 10 AND MP.IsPlaying = False Then MP.Position=0
				PlayMedia
			Else
				LoadMedia("",Media)
				MediaCountDown=UserOptions.MediaFileCountDown
				MPFileLoaded=True
				MediaPlayTimer.Enabled = True
				MediaPlayTimer_Tick
			End If
			
			
		Case "Pause"
		If MP.IsPlaying Then
			MP.Pause
		Else
			If MP.Duration-MP.Position < 10 Then MP.Position=0
		End If
			
		
		Case "Rew"
			MP.Position=MP.Position-1000
			Timer1_Tick
		Case "Fwd"
			MP.Position=MP.Position+1000
			Timer1_Tick
			
	End Select
	
End Sub
Sub Media_LongClick
	Dim Send As Button
	Send = Sender
	Select Send.Tag
				
		Case "Rew"
			MP.Position=MP.Position-10000
			Timer1_Tick
		Case "Fwd"
			MP.Position=MP.Position+10000
			Timer1_Tick
		Case "Play"
			MediaPnl.Visible=False
			MediaPlayBtn.Top=0
			MediaPlayBtn.Left=0
			MediaPlayBtn.Visible=True
			
	End Select
End Sub
Sub MediaPnl_Touch (Action As Int, X As Float, Y As Float)
		If Action = 0 Then
		'Determine The Start point
		MPYOffSet=Y
		MPYStart=MediaPnl.Top
		MPYComp=MPYStart
	End If
	
	If Action = 2 Then

		Dim XPos,YPos As Int
		YPos=MPYStart+Y-MPYOffSet
		
		If YPos < 0 Then YPos=0
		If YPos+MediaPnl.Height > ScreenHeight Then
			YPos=ScreenHeight-MediaPnl.Height
		End If
		
		MediaPnl.Top=YPos
		MediaPlayBtn.Top=YPos
			'Set up for next move
		MPYStart=MediaPnl.Top
		CurrMPY=MPYStart

	End If
	
	If Action = 1 AND Abs(MPYStart-MPYComp) < 5 Then
		'Not Moved Then Reset
		MediaPnl.Top=0
		MediaPlayBtn.Top=0
	End If
End Sub
Sub Timer1_Tick
    
	If MPFileLoaded Then
        MediaLbl.Text = ConvertToTimeFormat(MP.Position) & _
            " (" & ConvertToTimeFormat(MP.Duration) & ")"
	Else
		Timer1.Enabled=False
    End If
End Sub
'converts milliseconds to m:ss format.
Sub ConvertToTimeFormat(ms As Int) As String
    Dim seconds, minutes As Int
    seconds = Round(ms / 1000)
    minutes = Floor(seconds / 60)
    seconds = seconds Mod 60
    Return NumberFormat(minutes, 1, 0) & ":" & NumberFormat(seconds, 2, 0) 'ex: 3:05
End Sub
Sub DeleteKarFile
	KarFile=False
	File.Delete("",KarFileName)
End Sub
Sub TimeDispTimer_Tick
	TimeCount=TimeCount+1
	If TimeCount >=3 Then
		TimeDispTimer.Enabled=False
		TimePnl.Visible=False
	End If
End Sub
Sub NOSongNotesBtn_Click
		If SetListNotesFlag Then
			'Update SetList Notes
			If SetListNotes<>NotesText.Text Then
				SetListNotes=NotesText.Text
				Main.SongsDB.Initialize(File.DirDefaultExternal, "Songs.db", False)
				Main.SongsDB.ExecNonQuery2("UPDATE PlayListDat SET PLNotes = ? WHERE SongRowID = ? AND PLNAME = ?",Array As String(SetListNotes,Main.CurrSongRowID,SetLists.CurrentPlayList))
				Main.SongsDB.Close
			End If
			'Set Title
			NDTitle.Text="Song Notes For "&SongTitle
			NotesText.Text=SongNotes
			SetListNotesFlag=False
		End If
End Sub
Sub NOSetListNotesBtn_Click
		If Not(SetListNotesFlag) Then
			'check if song notes need to be saved
			If SongNotes<>NotesText.Text Then
				SongNotes=NotesText.Text
				Main.SongsDB.Initialize(File.DirDefaultExternal, "Songs.db", False)
				Main.SongsDB.ExecNonQuery2("UPDATE Songs SET Notes = ? WHERE ROWID = ?",Array As String(SongNotes,Main.CurrSongRowID))
				Main.SongsDB.Close
			End If
			'Set Title
			NDTitle.Text="Set List Notes For "&SongTitle
			' Load Set List Notes
			NotesText.Text=SetListNotes
			SetListNotesFlag=True
		End If
End Sub
Sub SLNotesOverlayPnl_Click
	SLNotesOverlayPnl.Visible=False	
End Sub

Sub SLNoOlay_Click
	SLNotesOverlayPnl.Visible=False
End Sub
Sub SetupChordLayoutPnl

	CLDevIDLbl.Text=ScreenWidth&ScreenHeight&Density
	
	'Select last selected item or first on list if none selected
	Selected=CLTypeDisp.SelectedIndex
	If Selected = -1 Then 
		Selected = 0
		CLTypeDisp.SelectedIndex=Selected
	End If
	
	
	
	'Select last selected item or first on list if none selected
	Selected=CLFontSizes.SelectedIndex
	If Selected = -1 Then 
		Selected = 0
		CLFontSizes.SelectedIndex=Selected
	End If
		
	
	
	'Click to keep selected field.
	Select CLSeekBar.Tag
		Case CLFontSizeLbl
			CLTypeDisp_ItemClick(CLTypeDisp.SelectedIndex,CLTypeDisp.SelectedItem)
			CLFontSizes_ItemClick(CLFontSizes.SelectedIndex,CLFontSizes.SelectedItem)
			CLFontSizeLbl_Click
		Case CLTypeDispLbl
			CLFontSizes_ItemClick(CLFontSizes.SelectedIndex,CLFontSizes.SelectedItem)
			CLTypeDisp_ItemClick(CLTypeDisp.SelectedIndex,CLTypeDisp.SelectedItem)
			CLTypeDispLbl_Click
		Case Else
			CLTypeDisp_ItemClick(CLTypeDisp.SelectedIndex,CLTypeDisp.SelectedItem)
			CLFontSizes_ItemClick(CLFontSizes.SelectedIndex,CLFontSizes.SelectedItem)
			CLFontSizeLbl_Click
	End Select
	
	CLPnlBGColour=Colors.ARGB(255,128,128,128)
	CLPnlBG.Visible=True
	CLPnlBG.BringToFront

	'Create a backup of current setting for restoring
	CurrOpts.Initialize
	
	'Fonts
	CurrOpts.TI = BuildSong.TITLE_TYPE_SIZE
	CurrOpts.SM = BuildSong.SONG_MARKS_TYPE_SIZE
	CurrOpts.CT = BuildSong.CHORDS_TYPE_SIZE
	CurrOpts.ST = BuildSong.SLASH_TYPE_SIZE
	CurrOpts.BT = BuildSong.BEATS_TYPE_SIZE
	CurrOpts.TT = BuildSong.TYPES_TYPE_SIZE
	CurrOpts.TS = BuildSong.TIME_SIG_TYPE_SIZE
	CurrOpts.TE = BuildSong.TEXT_SIZE
	
	'Display Types
	CurrOpts.CY = DisplaySong.ChordYOffset
	CurrOpts.TY = DisplaySong.TypesYOffset
	CurrOpts.SX = DisplaySong.DT_SingleXOffset
	CurrOpts.SXS = DisplaySong.DT_SingleXOffset_sm
	CurrOpts.SXA = DisplaySong.DT_SingleXOffsetAcc
	CurrOpts.SXAS = DisplaySong.DT_SingleXOffsetAcc_sm
	CurrOpts.SY = DisplaySong.DT_SingleYOffset
	CurrOpts.MX = DisplaySong.DT_MultiXOffset
	CurrOpts.MXS = DisplaySong.DT_MultiXOffset_sm
	CurrOpts.MXA = DisplaySong.DT_MultiXOffsetAcc
	CurrOpts.MXAS = DisplaySong.DT_MultiXOffsetAcc_sm
	CurrOpts.MY2 = DisplaySong.DT_MultiYStartOffset
	CurrOpts.MXL = DisplaySong.DT_MultiXLineOffset
	CurrOpts.MXLS = DisplaySong.DT_MultiXLineOffset_sm
	CurrOpts.MY3 = DisplaySong.DT_MultiYStart3Lines
	
	
	CurrOptsBak=CurrOpts
End Sub
Sub CLTypeDispET_EnterPressed

	If Not(IsNumber(CLTypeDispET.Text)) OR (CLTypeDispET.Text < SBTypeMin OR CLTypeDispET.Text > SBTypeMax) Then
		Msgbox("Please enter a number between "&SBTypeMin&" and "&SBTypeMax,"Invalid entry")
		Return False
	End If
				
	ThisVal = CLTypeDispET.Text
	
	Select CLTypeDisp.SelectedItem
		Case "Chord Y"
		DisplaySong.ChordYOffset = ThisVal
		Case "Type Y"
		DisplaySong.TypesYOffset = ThisVal
		Case "Single X"
		DisplaySong.DT_SingleXOffset = ThisVal
		Case "Single X sm"
		DisplaySong.DT_SingleXOffset_sm = ThisVal
		Case "Single X Acc"
		DisplaySong.DT_SingleXOffsetAcc = ThisVal
		Case "Single X Acc sm"
		DisplaySong.DT_SingleXOffsetAcc_sm = ThisVal
		Case "Single Y Start"
		DisplaySong.DT_SingleYOffset = ThisVal
		Case "Multi X"
		DisplaySong.DT_MultiXOffset = ThisVal
		Case "Multi X Sm"
		DisplaySong.DT_MultiXOffset_sm = ThisVal
		Case "Multi X Acc"
		DisplaySong.DT_MultiXOffsetAcc = ThisVal
		Case "Multi X Acc Sm"
		DisplaySong.DT_MultiXOffsetAcc_sm = ThisVal
		Case "Multi X Line 2"
		DisplaySong.DT_MultiXLineOffset = ThisVal
		Case "Multi X Line 2 Sm"
		DisplaySong.DT_MultiXLineOffset_sm = ThisVal
		Case "2 Line Y Start"
		DisplaySong.DT_MultiYStartOffset = ThisVal
		Case "3 Line Y Start"
			DisplaySong.DT_MultiYStart3Lines = ThisVal
			
	End Select
	
	CLTypeDispET.Visible=False
	CLTypeDispET.SendToBack
	SetupChordLayoutPnl
		
	'Redisplay Song
	DisplaySong.DisplaySong(Canvas1,ScreenWidth,ScreenHeight)
	Activity.Invalidate
	
End Sub
Sub CLSeekBar_ValueChanged (Value As Int, UserChanged As Boolean)

	If UserChanged Then
		Dim ThisLbl As Label
		ThisLbl=CLSeekBar.Tag
		Select ThisLbl
		
		Case CLFontSizeLbl
			ThisLbl.Text=Value + SBFontMin
			
			Select CLFontSizes.SelectedItem
		
				Case "Title Size"
					BuildSong.TITLE_TYPE_SIZE = ThisLbl.Text
					
				Case "Chord Size"
					BuildSong.CHORDS_TYPE_SIZE = ThisLbl.Text
					
				Case "Chord Type Size"
					BuildSong.TYPES_TYPE_SIZE = ThisLbl.Text
					
				Case "Song Marks Size"
					BuildSong.SONG_MARKS_TYPE_SIZE = ThisLbl.Text
					
				Case "Slash Chord Size"
					BuildSong.SLASH_TYPE_SIZE = ThisLbl.Text
					
				Case "Time Sig Size"
					BuildSong.TIME_SIG_TYPE_SIZE = ThisLbl.Text
					
				Case "Text size"
					BuildSong.TEXT_SIZE = ThisLbl.Text
				
		End Select
		
		Case CLTypeDispLbl
			ThisLbl.Text=Value + SBTypeMin
			
			Select CLTypeDisp.SelectedItem
				Case "Chord Y"
				DisplaySong.ChordYOffset = ThisLbl.Text
				Case "Type Y"
				DisplaySong.TypesYOffset = ThisLbl.Text
				Case "Single X"
				DisplaySong.DT_SingleXOffset = ThisLbl.Text
				Case "Single X sm"
				DisplaySong.DT_SingleXOffset_sm = ThisLbl.Text
				Case "Single X Acc"
				DisplaySong.DT_SingleXOffsetAcc = ThisLbl.Text
				Case "Single X Acc sm"
				DisplaySong.DT_SingleXOffsetAcc_sm = ThisLbl.Text
				Case "Single Y Start"
				DisplaySong.DT_SingleYOffset = ThisLbl.Text
				Case "Multi X"
				DisplaySong.DT_MultiXOffset = ThisLbl.Text
				Case "Multi X Sm"
				DisplaySong.DT_MultiXOffset_sm = ThisLbl.Text
				Case "Multi X Acc"
				DisplaySong.DT_MultiXOffsetAcc = ThisLbl.Text
				Case "Multi X Acc Sm"
				DisplaySong.DT_MultiXOffsetAcc_sm = ThisLbl.Text
				Case "Multi X Line 2"
				DisplaySong.DT_MultiXLineOffset = ThisLbl.Text
				Case "Multi X Line 2 Sm"
				DisplaySong.DT_MultiXLineOffset_sm = ThisLbl.Text
				Case "2 Line Y Start"
				DisplaySong.DT_MultiYStartOffset = ThisLbl.Text
				Case "3 Line Y Start"
				DisplaySong.DT_MultiYStart3Lines = ThisLbl.Text
			
			End Select
			
		End Select
		
		'Redisplay Song
		DisplaySong.DisplaySong(Canvas1,ScreenWidth,ScreenHeight)
		Activity.Invalidate
	End If
	
	
End Sub
Sub CLPnlResetBtn_Click

	Dim ThisLbl As Label
	ThisLbl=CLSeekBar.Tag
	
	Select ThisLbl
	
	Case CLFontSizeLbl
		
		Select CLFontSizes.SelectedItem

			Case "Title Size"
				BuildSong.TITLE_TYPE_SIZE = CurrOptsBak.TI
				CLFontSizeLbl.Text=CurrOptsBak.TI
				CLSeekBar.Value=CurrOptsBak.TI-SBFontMin
				
			Case "Chord Size"
				BuildSong.CHORDS_TYPE_SIZE = CurrOptsBak.CT
				CLFontSizeLbl.Text=CurrOptsBak.CT
				CLSeekBar.Value=CurrOptsBak.CT - SBFontMin
				
			Case "Chord Type Size"
				BuildSong.TYPES_TYPE_SIZE = CurrOptsBak.TT
				CLFontSizeLbl.Text=CurrOptsBak.TT
				CLSeekBar.Value=CurrOptsBak.TT - SBFontMin
				
			Case "Song Marks Size"
				BuildSong.SONG_MARKS_TYPE_SIZE = CurrOptsBak.SM
				CLFontSizeLbl.Text=CurrOptsBak.SM
				CLSeekBar.Value=CurrOptsBak.SM - SBFontMin
				
			Case "Slash Chord Size"
				BuildSong.SLASH_TYPE_SIZE = CurrOptsBak.ST
				CLFontSizeLbl.Text=CurrOptsBak.ST
				CLSeekBar.Value=CurrOptsBak.ST - SBFontMin
				
			Case "Time Sig Size"
				BuildSong.TIME_SIG_TYPE_SIZE = CurrOptsBak.TS
				CLFontSizeLbl.Text=CurrOptsBak.TS
				CLSeekBar.Value=CurrOptsBak.TS - SBFontMin
				
			Case "Text size"
				BuildSong.TEXT_SIZE = CurrOptsBak.TE
				CLFontSizeLbl.Text=CurrOptsBak.TE
				CLSeekBar.Value=CurrOptsBak.TE - SBFontMin
			
		End Select
		
	Case CLTypeDispLbl
	
		Select CLTypeDisp.SelectedItem
		
			Case "Chord Y"
			DisplaySong.ChordYOffset = CurrOptsBak.CY
			CLTypeDispLbl.Text = CurrOptsBak.CY
			CLSeekBar.Value = CurrOptsBak.CY - SBTypeMin
			
			Case "Type Y"
			DisplaySong.TypesYOffset = CurrOptsBak.TY
			CLTypeDispLbl.Text = CurrOptsBak.TY
			CLSeekBar.Value = CurrOptsBak.TY - SBTypeMin
	
			Case "Single X"
			DisplaySong.DT_SingleXOffset = CurrOptsBak.SX
			CLTypeDispLbl.Text = CurrOptsBak.SX
			CLSeekBar.Value = CurrOptsBak.SX - SBTypeMin
			
			Case "Single X sm"
			DisplaySong.DT_SingleXOffset_sm = CurrOptsBak.SXS
			CLTypeDispLbl.Text = CurrOptsBak.SXS
			CLSeekBar.Value = CurrOptsBak.SXS - SBTypeMin
			
			Case "Single X Acc"
			DisplaySong.DT_SingleXOffsetAcc = CurrOptsBak.SXA
			CLTypeDispLbl.Text = CurrOptsBak.SXA
			CLSeekBar.Value = CurrOptsBak.SXA - SBTypeMin
			
			Case "Single X Acc sm"
			DisplaySong.DT_SingleXOffsetAcc_sm = CurrOptsBak.SXAS
			CLTypeDispLbl.Text = CurrOptsBak.SXAS
			CLSeekBar.Value = CurrOptsBak.SXAS - SBTypeMin
			
			Case "Single Y Start"
			DisplaySong.DT_SingleYOffset = CurrOptsBak.SY
			CLTypeDispLbl.Text = CurrOptsBak.SY
			CLSeekBar.Value = CurrOptsBak.SY - SBTypeMin
			
			Case "Multi X"
			DisplaySong.DT_MultiXOffset = CurrOptsBak.MX
			CLTypeDispLbl.Text = CurrOptsBak.MX
			CLSeekBar.Value = CurrOptsBak.MX - SBTypeMin
			
			Case "Multi X Sm"
			DisplaySong.DT_MultiXOffset_sm = CurrOptsBak.MXS
			CLTypeDispLbl.Text = CurrOptsBak.MXS
			CLSeekBar.Value = CurrOptsBak.MXS - SBTypeMin
			
			Case "Multi X Acc"
			DisplaySong.DT_MultiXOffsetAcc = CurrOptsBak.MXA
			CLTypeDispLbl.Text = CurrOptsBak.MXA
			CLSeekBar.Value = CurrOptsBak.MXA - SBTypeMin
			
			Case "Multi X Acc Sm"
			DisplaySong.DT_MultiXOffsetAcc_sm = CurrOptsBak.MXAS
			CLTypeDispLbl.Text = CurrOptsBak.MXAS
			CLSeekBar.Value = CurrOptsBak.MXAS - SBTypeMin
			
			Case "Multi X Line 2"
			DisplaySong.DT_MultiXLineOffset = CurrOptsBak.MXL
			CLTypeDispLbl.Text = CurrOptsBak.MXL
			CLSeekBar.Value = CurrOptsBak.MXL - SBTypeMin
			
			Case "Multi X Line 2 Sm"
			DisplaySong.DT_MultiXLineOffset_sm = CurrOptsBak.MXLS
			CLTypeDispLbl.Text = CurrOptsBak.MXLS
			CLSeekBar.Value = CurrOptsBak.MXLS - SBTypeMin
			
			Case "2 Line Y Start"
			DisplaySong.DT_MultiYStartOffset = CurrOptsBak.MY2
			CLTypeDispLbl.Text = CurrOptsBak.MY2
			CLSeekBar.Value = CurrOptsBak.MY2 - SBTypeMin
			
			Case "3 Line Y Start"
			DisplaySong.DT_MultiYStart3Lines = CurrOptsBak.MY3
			CLTypeDispLbl.Text = CurrOptsBak.MY3
			CLSeekBar.Value = CurrOptsBak.MY3 - SBTypeMin
			
		End Select
			
	End Select
	
	DisplaySong.DisplaySong(Canvas1,ScreenWidth,ScreenHeight)
	Activity.Invalidate
End Sub
Sub CLPnlBG_Click
	
End Sub
Sub CLPnlBG_LongClick
	
End Sub
Sub CLFontSizesET_EnterPressed

	If Not(IsNumber(CLFontSizesET.Text)) OR (CLFontSizesET.Text < SBFontMin OR CLFontSizesET.Text > SBFontMax) Then
		Msgbox("Please enter a number between "&SBFontMin&" AND "&(SBFontMax),"Invalid Entry")
		Return False
	End If

	ThisVal = CLFontSizesET.Text

	Select CLFontSizes.SelectedItem
	
		Case "Title Size"
			BuildSong.TITLE_TYPE_SIZE = ThisVal
			
		Case "Chord Size"
			BuildSong.CHORDS_TYPE_SIZE = ThisVal
			
		Case "Chord Type Size"
			BuildSong.TYPES_TYPE_SIZE = ThisVal
			
		Case "Song Marks Size"
			BuildSong.SONG_MARKS_TYPE_SIZE = ThisVal
			
		Case "Slash Chord Size"
			BuildSong.SLASH_TYPE_SIZE = ThisVal
			
		Case "Time Sig Size"
			BuildSong.TIME_SIG_TYPE_SIZE = ThisVal
			
		Case "Text size"
			BuildSong.TEXT_SIZE = ThisVal
		
	End Select
	
	CLFontSizesET.Visible=False
	CLFontSizesET.SendToBack
	SetupChordLayoutPnl
		
	'Redisplay Song
	DisplaySong.DisplaySong(Canvas1,ScreenWidth,ScreenHeight)
	Activity.Invalidate
	
End Sub
Sub LoadCLSpinners
	CLFontSizes.AddAll(Array As String("Title Size","Chord Size","Chord Type Size","Song Marks Size","Slash Chord Size","Time Sig Size","Text size"))
	CLTypeDisp.AddAll(Array As String("Chord Y","Type Y","Single X","Single X sm","Single X Acc","Single X Acc sm","Single Y Start","Multi X","Multi X Sm","Multi X Acc","Multi X Acc Sm","Multi X Line 2","Multi X Line 2 Sm","2 Line Y Start","3 Line Y Start"))
End Sub
Sub CLFontSizeLbl_Click
	If CLTypeDispET.Visible Then
		Result=CLTypeDispET_EnterPressed
		If Result = False Then Return
	End If

	CLTypeDispLblBG.Color=CLPnlBGColour
	CLFontSizesLblBG.Color=Colors.Cyan
	CLSeekBar.Tag=CLFontSizeLbl
	CLSeekBar.Max=SBFontMax-SBFontMin
	CLEditingFont=True
	
	
	Select CLFontSizes.SelectedItem
	
		Case "Title Size"
			CLSeekBar.Value = BuildSong.TITLE_TYPE_SIZE - SBFontMin
			
		Case "Chord Size"
			CLSeekBar.Value = BuildSong.CHORDS_TYPE_SIZE - SBFontMin
			
		Case "Chord Type Size"
			CLSeekBar.Value = BuildSong.TYPES_TYPE_SIZE - SBFontMin
			
		Case "Song Marks Size"
			CLSeekBar.Value = BuildSong.SONG_MARKS_TYPE_SIZE - SBFontMin
			
		Case "Slash Chord Size"
			CLSeekBar.Value = BuildSong.SLASH_TYPE_SIZE - SBFontMin
			
		Case "Time Sig Size"
			CLSeekBar.Value = BuildSong.TIME_SIG_TYPE_SIZE - SBFontMin
			
		Case "Text size"
			CLSeekBar.Value = BuildSong.TEXT_SIZE - SBFontMin
		
	End Select
	
End Sub
Sub CLTypeDispLbl_Click

	If CLFontSizesET.Visible Then
		Result=CLFontSizesET_EnterPressed
		If Result = False Then Return
	End If
	
	CLTypeDispLblBG.Color=Colors.Cyan
	CLFontSizesLblBG.Color=CLPnlBGColour
	CLSeekBar.Tag=CLTypeDispLbl
	CLSeekBar.Max=SBTypeMax-SBTypeMin
	CLEditingFont=False
	
	Select CLTypeDisp.SelectedItem
	
		Case "Chord Y"
			
			CLSeekBar.Value = DisplaySong.ChordYOffset - SBTypeMin
			
		Case "Type Y"

			CLSeekBar.Value = DisplaySong.TypesYOffset - SBTypeMin
	
		Case "Single X"
			'CLTypeDispLbl.Text = DisplaySong.DT_SingleXOffset
			CLSeekBar.Value = DisplaySong.DT_SingleXOffset - SBTypeMin
		Case "Single X sm"
			'CLTypeDispLbl.Text = DisplaySong.DT_SingleXOffset_sm
			CLSeekBar.Value = DisplaySong.DT_SingleXOffset_sm - SBTypeMin
		Case "Single X Acc"
			'CLTypeDispLbl.Text = DisplaySong.DT_SingleXOffsetAcc
			CLSeekBar.Value = DisplaySong.DT_SingleXOffsetAcc - SBTypeMin
		Case "Single X Acc sm"
			'CLTypeDispLbl.Text = DisplaySong.DT_SingleXOffsetAcc_sm
			CLSeekBar.Value = DisplaySong.DT_SingleXOffsetAcc_sm - SBTypeMin
		Case "Single Y Start"
			'CLTypeDispLbl.Text = DisplaySong.DT_SingleYOffset
			CLSeekBar.Value = DisplaySong.DT_SingleYOffset - SBTypeMin
		Case "Multi X"
			'CLTypeDispLbl.Text = DisplaySong.DT_MultiXOffset
			CLSeekBar.Value = DisplaySong.DT_MultiXOffset - SBTypeMin
		Case "Multi X Sm"
			'CLTypeDispLbl.Text = DisplaySong.DT_MultiXOffset_sm
			CLSeekBar.Value = DisplaySong.DT_MultiXOffset_sm - SBTypeMin
		Case "Multi X Acc"
			'CLTypeDispLbl.Text = DisplaySong.DT_MultiXOffsetAcc
			CLSeekBar.Value = DisplaySong.DT_MultiXOffsetAcc - SBTypeMin
		Case "Multi X Acc Sm"
			'CLTypeDispLbl.Text = DisplaySong.DT_MultiXOffsetAcc_sm
			CLSeekBar.Value = DisplaySong.DT_MultiXOffsetAcc_sm - SBTypeMin
		Case "Multi X Line 2"
			'CLTypeDispLbl.Text = DisplaySong.DT_MultiXLineOffset
			CLSeekBar.Value = DisplaySong.DT_MultiXLineOffset - SBTypeMin
		Case "Multi X Line 2 Sm"
			'CLTypeDispLbl.Text = DisplaySong.DT_MultiXLineOffset_sm
			CLSeekBar.Value = DisplaySong.DT_MultiXLineOffset_sm - SBTypeMin
		Case "2 Line Y Start"
			'CLTypeDispLbl.Text = DisplaySong.DT_MultiYStartOffset
			CLSeekBar.Value = DisplaySong.DT_MultiYStartOffset - SBTypeMin
		Case "3 Line Y Start"
			'CLTypeDispLbl.Text = DisplaySong.DT_MultiYStart3Lines
			CLSeekBar.Value = DisplaySong.DT_MultiYStart3Lines - SBTypeMin
	End Select
End Sub
Sub CLTypeDispLbl_LongClick
		CloseCLET
		CLTypeDispLbl_Click
		CLTypeDispET.Text=CLTypeDispLbl.Text
		CLEditingFont=False
		CLTypeDispET.Visible=True
		CLTypeDispET.BringToFront
End Sub
Sub CLFontSizeLbl_LongClick
	CLFontSizeLbl_Click
	CloseCLET
	CLFontSizesET.Text = CLFontSizeLbl.Text
	CLEditingFont=True
	CLFontSizesET.Visible=True
	CLFontSizesET.BringToFront
End Sub
Sub CLTypeDisp_ItemClick (Position As Int, Value As Object)

	CloseCLET

	CLSeekBar.Tag=CLTypeDispLbl
	CLSeekBar.Max=SBTypeMax-SBTypeMin
	

	Select Value
	
		Case "Chord Y"
			CLTypeDispLbl.Text = DisplaySong.ChordYOffset
		Case "Type Y"			
			CLTypeDispLbl.Text = DisplaySong.TypesYOffset
		Case "Single X"
			CLTypeDispLbl.Text = DisplaySong.DT_SingleXOffset
			'CLSeekBar.Value = DisplaySong.DT_SingleXOffset - SBTypeMin
		Case "Single X sm"
			CLTypeDispLbl.Text = DisplaySong.DT_SingleXOffset_sm
			'CLSeekBar.Value = DisplaySong.DT_SingleXOffset_sm - SBTypeMin
		Case "Single X Acc"
			CLTypeDispLbl.Text = DisplaySong.DT_SingleXOffsetAcc
			'CLSeekBar.Value = DisplaySong.DT_SingleXOffsetAcc - SBTypeMin
		Case "Single X Acc sm"
			CLTypeDispLbl.Text = DisplaySong.DT_SingleXOffsetAcc_sm
			'CLSeekBar.Value = DisplaySong.DT_SingleXOffsetAcc_sm - SBTypeMin
		Case "Single Y Start"
			CLTypeDispLbl.Text = DisplaySong.DT_SingleYOffset
			'CLSeekBar.Value = DisplaySong.DT_SingleYOffset - SBTypeMin
		Case "Multi X"
			CLTypeDispLbl.Text = DisplaySong.DT_MultiXOffset
			'CLSeekBar.Value = DisplaySong.DT_MultiXOffset - SBTypeMin
		Case "Multi X Sm"
			CLTypeDispLbl.Text = DisplaySong.DT_MultiXOffset_sm
			'CLSeekBar.Value = DisplaySong.DT_MultiXOffset_sm - SBTypeMin
		Case "Multi X Acc"
			CLTypeDispLbl.Text = DisplaySong.DT_MultiXOffsetAcc
			'CLSeekBar.Value = DisplaySong.DT_MultiXOffsetAcc - SBTypeMin
		Case "Multi X Acc Sm"
			CLTypeDispLbl.Text = DisplaySong.DT_MultiXOffsetAcc_sm
			'CLSeekBar.Value = DisplaySong.DT_MultiXOffsetAcc_sm - SBTypeMin
		Case "Multi X Line 2"
			CLTypeDispLbl.Text = DisplaySong.DT_MultiXLineOffset
			'CLSeekBar.Value = DisplaySong.DT_MultiXLineOffset - SBTypeMin
		Case "Multi X Line 2 Sm"
			CLTypeDispLbl.Text = DisplaySong.DT_MultiXLineOffset_sm
			'CLSeekBar.Value = DisplaySong.DT_MultiXLineOffset_sm - SBTypeMin
		Case "2 Line Y Start"
			CLTypeDispLbl.Text = DisplaySong.DT_MultiYStartOffset
			'CLSeekBar.Value = DisplaySong.DT_MultiYStartOffset - SBTypeMin
		Case "3 Line Y Start"
			CLTypeDispLbl.Text = DisplaySong.DT_MultiYStart3Lines
			'CLSeekBar.Value = DisplaySong.DT_MultiYStart3Lines - SBTypeMin
	End Select
	
	'Make sure the right field is selected and set seek bar values
	CLTypeDispLbl_Click
End Sub
Sub CloseCLET
	
	CLFontSizesET.Visible=False
	CLFontSizesET.SendToBack
	CLTypeDispET.Visible=False
	CLTypeDispET.SendToBack
	
End Sub
Sub CLFontSizes_ItemClick (Position As Int, Value As Object)

	CloseCLET

	CLSeekBar.Tag=CLFontSizeLbl
	CLSeekBar.Max=SBFontMax-SBFontMin
	SBMin=SBFontMin

	Select Value
	
		Case "Title Size"
			CLFontSizeLbl.Text=BuildSong.TITLE_TYPE_SIZE
			'CLSeekBar.Value=BuildSong.TITLE_TYPE_SIZE - SBFontMin
		Case "Chord Size"
			CLFontSizeLbl.Text=BuildSong.CHORDS_TYPE_SIZE
			'CLSeekBar.Value=BuildSong.CHORDS_TYPE_SIZE - SBFontMin
		Case "Chord Type Size"
			CLFontSizeLbl.Text=BuildSong.TYPES_TYPE_SIZE
			'CLSeekBar.Value=BuildSong.TYPES_TYPE_SIZE - SBFontMin
		Case "Song Marks Size"
			CLFontSizeLbl.Text=BuildSong.SONG_MARKS_TYPE_SIZE
			'CLSeekBar.Value=BuildSong.SONG_MARKS_TYPE_SIZE - SBFontMin
		Case "Slash Chord Size"
			CLFontSizeLbl.Text=BuildSong.SLASH_TYPE_SIZE
			'CLSeekBar.Value=BuildSong.SLASH_TYPE_SIZE - SBFontMin
		Case "Time Sig Size"
			CLFontSizeLbl.Text=BuildSong.TIME_SIG_TYPE_SIZE
			'CLSeekBar.Value=BuildSong.TIME_SIG_TYPE_SIZE - SBFontMin
		Case "Text size"
			CLFontSizeLbl.Text=BuildSong.TEXT_SIZE
			'CLSeekBar.Value=BuildSong.TEXT_SIZE - SBFontMin
			
	End Select
	'Make Sure right field is selected and update seekbar pos
	CLFontSizeLbl_Click
End Sub
Sub CLResetAllBtn_Click

	Response=Msgbox2("Are you sure, you will lose all current changes","Reset to stored settings","Yes","No","",Main.MsgIcon)
	If Response = DialogResponse.CANCEL Then Return

	BuildSong.TITLE_TYPE_SIZE = CurrOptsBak.TI
	BuildSong.TYPES_TYPE_SIZE = CurrOptsBak.TT
	BuildSong.CHORDS_TYPE_SIZE = CurrOptsBak.CT
	BuildSong.SONG_MARKS_TYPE_SIZE = CurrOptsBak.SM
	BuildSong.SLASH_TYPE_SIZE = CurrOptsBak.ST
	BuildSong.TIME_SIG_TYPE_SIZE = CurrOptsBak.TS
	BuildSong.TEXT_SIZE = CurrOptsBak.TE
	
	DisplaySong.ChordYOffset=CurrOpts.CY
	DisplaySong.TypesYOffset=CurrOpts.TY
	DisplaySong.DT_SingleXOffset = CurrOptsBak.SX
	DisplaySong.DT_SingleXOffset_sm = CurrOptsBak.SXS
	DisplaySong.DT_SingleXOffsetAcc = CurrOptsBak.SXA
	DisplaySong.DT_SingleXOffsetAcc_sm = CurrOptsBak.SXAS
	DisplaySong.DT_SingleYOffset = CurrOptsBak.SY
	DisplaySong.DT_MultiXOffset = CurrOptsBak.MX
	DisplaySong.DT_MultiXOffset_sm = CurrOptsBak.MXS
	DisplaySong.DT_MultiXOffsetAcc = CurrOptsBak.MXA
	DisplaySong.DT_MultiXOffsetAcc_sm = CurrOptsBak.MXAS
	DisplaySong.DT_MultiXLineOffset = CurrOptsBak.MXL
	DisplaySong.DT_MultiXLineOffset_sm = CurrOptsBak.MXLS
	DisplaySong.DT_MultiYStartOffset = CurrOptsBak.MY2
	DisplaySong.DT_MultiYStart3Lines = CurrOptsBak.MY3
	
	'Reset layout
	SetupChordLayoutPnl
	
	DisplaySong.DisplaySong(Canvas1,ScreenWidth,ScreenHeight)
	Activity.Invalidate
End Sub

Sub CLResetDefBtn_Click

	Response=Msgbox2("Are you sure, this will reset to software defaults","Reset to defaults","Yes","No","",Main.MsgIcon)
	If Response = DialogResponse.CANCEL Then Return
	
	BuildSong.ResetDispOpts
	SetupChordLayoutPnl
	DisplaySong.DisplaySong(Canvas1,ScreenWidth,ScreenHeight)
	Activity.Invalidate
End Sub
Sub CLDoneBtn_Click
	CLPnlBG.Visible=False	
End Sub
Sub ClPnlMove_Touch (Action As Int, X As Float, Y As Float)
	If Action = 0 Then
		'Determine The Start point
		ETXOffSet=X
		ETYOffSet=Y
		ETXStart=CLPnl.Left
		ETYStart=CLPnl.Top
		ETXComp=ETXStart
		ETYComp=ETYStart
	End If
	
	If Action = 2 Then

		Dim XPos,YPos As Int
		XPos=ETXStart+X-ETXOffSet
		YPos=ETYStart+Y-ETYOffSet
		
		If XPos < 0 Then XPos=0
		If YPos < 0 Then YPos=0
		If XPos+CLPnl.Width > ScreenWidth Then XPos = ScreenWidth - CLPnl.Width
		If YPos+CLPnl.Height > ScreenHeight+CLPnl.Height-30 Then YPos = ScreenHeight-CLPnl.Height+30
		
		CLPnl.Top=YPos
		CLPnl.Left=XPos
			'Set up for next move
		ETXStart=CLPnl.Left
		ETYStart=CLPnl.Top

	End If
	
	If Action = 1 AND ETXStart=ETXComp AND ETYStart=ETYComp Then
		'Not Moved Then Reset
		CLPnl.Left=ETXOrig
		CLPnl.Top=ETYOrig
	End If
	
End Sub
Sub NPSBFontSize_ValueChanged (Value As Int, UserChanged As Boolean)
	If UserChanged Then
		If NOEText.Visible Then
			Result=NOEText_EnterPressed
			If Result= False Then
				NPSBFontSize.Value=NotesText.TextSize - SBFontMin
				Return
			End If
		End If
		Dim ThisVal As Int
		ThisVal=Value
		NotesText.TextSize=ThisVal + SBFontMin
		SLNoOlay.TextSize=ThisVal + SBFontMin
		UserOptions.NotesFontSize=ThisVal + SBFontMin
		NPFontSize.Text=ThisVal + SBFontMin
			
	End If
	
End Sub

Sub NPBtnDone_Click
	NotesOptPnlBG.Visible=False
	NotesOptPnlBG.SendToBack
End Sub
Sub NotesOptPnlBG_Click
	
End Sub
Sub NotesOptPnlBG_LongClick
	
End Sub
Sub NotesOptPnl_Click
	
End Sub
Sub NotesOptPnl_LongClick
	
End Sub
Sub NotesOptions
	
	Dim TextSize As Int
	
	If NotesWindow.IsInitialized =False OR NotesWindow.Visible = False Then
		ToastMessageShow("Open the notes window first",False)
		Return
	End If
	
	If NotesOptPnlBG.IsInitialized = False Then
		Activity.LoadLayout("NotesOptions.bal")
		NotesOptPnlBG.SetLayout(0,0,100%x,100%y)
		NotesOptPnl.Top = (NotesOptPnlBG.Height-NotesOptPnl.Height)/2
		NotesOptPnl.Left =(NotesOptPnlBG.Width-NotesOptPnl.Width)/2
		
		'Load Spinner Options
		NotesOptColorSp.AddAll(Array As String("As Screen Colours","Black on White","White on Black"))
	End If
	


	'Load Current Settings
	
	Select UserOptions.NotesColors
		Case "W"
		 	NotesOptColorSp.SelectedIndex = 2
		Case "B"
			NotesOptColorSp.SelectedIndex = 1
		Case "A"
			NotesOptColorSp.SelectedIndex = 0
	End Select
	
	TextSize=NotesText.TextSize
	NPFontSize.Text=TextSize
	
	NPSBFontSize.Max=SBFontMax - SBFontMin
	NPSBFontSize.Value=TextSize - SBFontMin
	
	NotesOptPnlBG.Visible=True
	NotesOptPnlBG.BringToFront
	
End Sub
Sub NOEText_EnterPressed
	If Not(IsNumber(NOEText.Text)) OR (NOEText.Text < SBFontMin OR NOEText.Text > SBFontMax) Then
		Msgbox("Please enter a number between "&SBFontMin&" AND "&(SBFontMax),"Invalid Entry")
		Return False
	End If
	Dim ThisNo As Int
	ThisNo = NOEText.Text
	NotesText.TextSize=ThisNo
	SLNoOlay.TextSize=ThisNo
	NPSBFontSize.Value=ThisNo - SBFontMin
	UserOptions.NotesFontSize=ThisNo
	NPFontSize.Text=ThisNo
	NOEText.Visible=False
	NOEText.SendToBack
End Sub
Sub NPFontSize_LongClick
	NOEText.Text=NPFontSize.Text
	NOEText.Visible=True
	NOEText.BringToFront
End Sub
Sub NotesOptColorSp_ItemClick (Position As Int, Value As Object)

	Select Position
	
	Case 1
		'Black on White
		UserOptions.NotesColors = "B"
		NotesText.Color=Colors.White
		NotesText.TextColor=Colors.Black
		SLNoOlay.Color=Colors.White
		SLNoOlay.TextColor=Colors.Black
	Case 2
		'White on Black
		UserOptions.NotesColors = "W"
		NotesText.Color=Colors.Black
		NotesText.TextColor=Colors.White
		SLNoOlay.Color=Colors.Black
		SLNoOlay.TextColor=Colors.White
	Case "0"
		'As Screen colours
		UserOptions.NotesColors = "A"
		If UserOptions.ScreenColors = "B" Then
			NotesText.Color=Colors.White
			NotesText.TextColor=Colors.Black
			SLNoOlay.Color=Colors.White
			SLNoOlay.TextColor=Colors.Black
		Else
			NotesText.Color=Colors.Black
			NotesText.TextColor=Colors.White
			SLNoOlay.Color=Colors.Black
			SLNoOlay.TextColor=Colors.White
		End If
	
	End Select
End Sub
Sub	OrientationLock_Click
	'Redirect
	Utils.OrientationLock_Click(OrientationLock)
End Sub
Sub Piano_Click
	' Turn of piano view
	Piano.Visible=False
End Sub
Sub Piano_LongClick
End Sub